﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;

namespace DistanceBetweenLines
{
    class Program
    {
        static void Main(string[] args)
        {
            LineShape line1 = new LineShape();
            line1.Vertices.Add(new Vertex(0, 0));
            line1.Vertices.Add(new Vertex(0, 10000));

            LineShape line2 = new LineShape();
            line2.Vertices.Add(new Vertex(500, 0));
            line2.Vertices.Add(new Vertex(500, 10000));

            // Should be 500m
            double distanceBetween = Math.Round(line2.GetDistanceTo(line1, GeographyUnit.Meter, DistanceUnit.Meter), 1);

            Console.WriteLine(string.Format("The distance between the lines is {0} m.", distanceBetween));

            // Lets do the same thing with points
            PointShape point1 = new PointShape(0, 0);
            PointShape point2 = new PointShape(500, 0);

            distanceBetween = Math.Round(point1.GetDistanceTo(point2, GeographyUnit.Meter, DistanceUnit.Meter), 1);

            Console.WriteLine(string.Format("The distance between the points is {0} m.", distanceBetween));

            // Now try point to line
            distanceBetween = Math.Round(point1.GetDistanceTo(line2, GeographyUnit.Meter, DistanceUnit.Meter), 1);

            Console.WriteLine(string.Format("The distance between point 1 and line 2 is {0} m.", distanceBetween));

        }
    }
}
